#!/bin/bash
VER=1.0
########################################################
###                                                  ###
###           Creditsystem by Xtreame                ###
### This Script gives you the folling commands in    ###
### irc: !show, !give, !take and !transfer           ###
### Put x-credit.sh in /glftpd/bin and chmod it 755  ###
### Put x-credit.tcl in your bot dir, change your    ###
### eggdrop.conf and rehash the bot                  ###
### The dirs below in glftpd must world write able   ###
### chmod 777 /glftpd/ftp-data/msgs                  ###
### chmod 777 /glftpd/ftp-data/users and the         ###
### chmod 666 /glftpd/ftp-data/users/*               ###
### chmod 755 x-credit.tcl                           ###
### to send Users a msg set sendmsg to 1             ###
###                                                  ###
### To give or take credits you must have the flags  ###
### F = take                                         ###
### G = give                                         ###
### read glftpd.docs find out more infos            ###
###                                                  ###
########################################################
###                                                  ###
### This script needs tur-passchk to work correctly ###
### so take a look at http://www.grandis.nu/glftpd/  ###
### and search for passchk in the download section   ###
###                                                  ###
########################################################
###                                                  ###
### The Script checks the users flag, available     ###
### Credits and the users ratio                      ###
###                                                  ###
########################################################
###                                                  ###
###            Great thanks to turranius             ###
###               for his tur-passchk                ###
###                                                  ###
########################################################

glroot="/glftpd"

userpath="/ftp-data/users/"

passwd="/bin/tur-passchk"

passfile="/etc/passwd"

sendmsg="0"

msgsdir="/ftp-data/msgs"

######--- don't change anything below this line ---######

action=$1
suser=$2
spass=$3
gtcuser=$4
gtmb=$5

proc_msgs() {
if [ "$glroot$msgsdir" ]; then
	if [ "$1" = "give" ]; then
		echo "---------------------------------------------------" >> $glroot$msgsdir/$3
		echo "$2 gives you $4 MB Credits" >> $glroot$msgsdir/$3
		echo "!HThis message was generated by X-Credit-System $VER" >> $glroot$msgsdir/$3
		echo " " >> $glroot$msgsdir/$3
		chmod 666 $glroot$msgsdir/$3 >/dev/null 2>&1
	fi
	if [ "$1" = "take" ]; then
		echo "---------------------------------------------------" >> $glroot$msgsdir/$3
		echo "$2 takes from you $4 MB Credits" >> $glroot$msgsdir/$3
		echo "!HThis message was generated by X-Credit-System $VER" >> $glroot$msgsdir/$3
		echo " " >> $glroot$msgsdir/$3
		chmod 666 $glroot$msgsdir/$3 >/dev/null 2>&1
	fi
	if [ "$1" = "transfer" ]; then
		echo "---------------------------------------------------" >> $glroot$msgsdir/$3
		echo "$2 transfers to you $4 MB Credits" >> $glroot$msgsdir/$3
		echo "!HThis message was generated by X-Credit-System $VER" >> $glroot$msgsdir/$3
		echo " " >> $glroot$msgsdir/$3
		chmod 666 $glroot$msgsdir/$3 >/dev/null 2>&1
	fi
fi
}

proc_announce() {
if [ "$1" = "show" ]; then
	echo "You have $2 MB Credits and ratio $3"
elif [ "$1" = "error" ]; then
	if [ "$2" = "noratio" ]; then
		echo "You have ratio 0"
	elif [ "$2" = "badpass" ]; then
		echo "Your Password is not correct"
	elif [ "$2" = "nocredit" ]; then
		echo "You have not enough credits"
	elif [ "$2" = "noflag" ]; then
		echo "You have no access to this command"
	elif [ "$2" = "notrans" ]; then
		echo "No transfer possible"
	elif [ "$2" = "noexist" ]; then
		echo "The User $3 does not exist."
	fi
elif [ "$1" = "give" ]; then
	echo "$2 gives $4 MB to $3"
elif [ "$1" = "take" ]; then
	echo "$2 takes $4 MB from $3"
elif [ "$1" = "transfer" ]; then
	echo "User $2 have transfers $4 MB to user $3."
fi
}

if [ ! -e "$glroot$passwd" ]; then
	echo "Error, no tur-passchk would found."
	exit 0
fi

if [ "$1" = "show" ]; then
	if [ "$2" -a "$3" ]; then
		user="$glroot$userpath$2"
		if [ ! -r "$user" ]; then
			proc_announce "error" "noexist" "$2"
			exit 0
		fi
		mpw=`$glroot$passwd $2 $3 $glroot$passfile`
		scheck=`cat $user | grep -e "^RATIO" | cut -d ' ' -f2`
		if [ "$mpw" = "MATCH" ]; then
			if [ ! "$scheck" = "0" ]; then
				cred=`cat $user | grep -e "^CREDITS" | awk '{print $2}'`
				let mb=1024
				let sh=$cred/$mb
				proc_announce "show" "$sh" "$scheck"
				exit 0
			else
				proc_announce "error" "noratio"
				exit 0
			fi
		else
			proc_announce "error" "badpass"
			exit 0
		fi
	fi
elif [ "$1" = "give" ]; then
	if [ "$2" -a "$3" -a "$4" -a "$5" ]; then
		sop="$glroot$userpath$2"
		user="$glroot$userpath$4"
		if [ ! -r "$sop" ]; then
			proc_announce "error" "noexist" "$2"
			exit 0
		fi
		if [ ! -r "$user" ]; then
			proc_announce "error" "noexist" "$4"
			exit 0
		fi
		flag=`cat $sop | grep -e "^FLAGS" | awk '{print $2}'`
		ifflag=`echo $flag | grep -e [G] | awk '{print $1}'`
		if [ "$ifflag" ]; then
			mpw=`$glroot$passwd $2 $3 $glroot$passfile`
			if [ "$mpw" = "MATCH" ]; then
				cred=`cat $user | grep -e "^CREDITS" | awk '{print $2}'`
				let mb=1024
				let gs=$5*$mb
				let sh=$cred+$gs
				chk=`cat $user | sed -e s/${cred}/${sh}/g > $user.lock`
				mv -f $user.lock $user
				chmod 666 $user >/dev/null 2>&1
				proc_announce "give" "$2" "$4" "$5"
				if [ "$sendmsg" = "1" ]; then
					proc_msgs "give" "$2" "$4" "$5"
				fi
				exit 0
			else
				proc_announce "error" "badpass"
				exit 0
			fi
		else
			proc_announce "error" "noflag"
			exit 0
		fi
	fi
elif [ "$1" = "take" ]; then
	if [ "$2" -a "$3" -a "$4" -a "$5" ]; then
		sop="$glroot$userpath$2"
		user="$glroot$userpath$4"
		if [ ! -r "$sop" ]; then
			proc_announce "error" "noexist" "$2"
			exit 0
		fi
		if [ ! -r "$user" ]; then
			proc_announce "error" "noexist" "$4"
			exit 0
		fi
		flag=`cat $sop | grep -e "^FLAGS" | awk '{print $2}'`
		ifflag=`echo $flag | grep -e [F] | awk '{print $1}'`
		if [ "$ifflag" ]; then
			mpw=`$glroot$passwd $2 $3 $glroot$passfile`
			if [ "$mpw" = "MATCH" ]; then
				cred=`cat $user | grep -e "^CREDITS" | awk '{print $2}'`
				let mb=1024
				let gs=$5*$mb
				let sh=$cred-$gs
				chk=`cat $user | sed -e s/${cred}/${sh}/g > $user.lock`
				mv -f $user.lock $user
				chmod 666 $user >/dev/null 2>&1
				proc_announce "take" "$2" "$4" "$5"
				if [ "$sendmsg" = "1" ]; then
					proc_msgs "take" "$2" "$4" "$5"
				fi
				exit 0
			else
				proc_announce "error" "badpass"
				exit 0
			fi
		else
			proc_announce "error" "noflag"
		fi
	fi
elif [ "$1" = "transfer" ]; then
	if [ "$2" -a "$3" -a "$4" -a "$5" ]; then
		tuser="$glroot$userpath$2"
		guser="$glroot$userpath$4"
		if [ ! -r "$tuser" ]; then
			proc_announce "error" "noexist" "$2"
			exit 0
		fi
		if [ ! -r "$guser" ]; then
			proc_announce "error" "noexist" "$4"
			exit 0
		fi
		mpw=`$glroot$passwd $2 $3 $glroot$passfile`
			if [ "$mpw" = "MATCH" ]; then
				tcheck=`cat $tuser | grep -e "^RATIO" | cut -d ' ' -f2`
				gcheck=`cat $guser | grep -e "^RATIO" | cut -d ' ' -f2`
					if [ ! "$tcheck" = "0" -a ! "$gcheck" = "0" ]; then
						tcred=`cat $tuser | grep -e "^CREDITS" | awk '{print $2}'`
						gcred=`cat $guser | grep -e "^CREDITS" | awk '{print $2}'`
						let mb=1024
						let gs=$5*$mb
						if [ "$tcred" -gt "$gs" ]; then
							let tc=$tcred-$gs
							tcs=`cat $tuser | sed -e s/${tcred}/${tc}/g > $tuser.lock`
							mv -f $tuser.lock $tuser
							chmod 666 $tuser >/dev/null 2>&1
							let gc=$gcred+$gs
							gcs=`cat $guser | sed -e s/${gcred}/${gc}/g > $guser.lock`
							mv -f $guser.lock $guser
							chmod 666 $guser >/dev/null 2>&1
							proc_announce "transfer" "$2" "$4" "$5"
							if [ "$sendmsg" = "1" ]; then
								proc_msgs "transfer" "$2" "$4" "$5"
							fi
							exit 0
						else
							proc_announce "error" "nocredits"
							exit 0
						fi
					else
						proc_announce "error" "notrans"
						exit 0
					fi
			else
				proc_announce "error" "badpass"
				exit 0
			fi
	fi
fi

exit 0
